#include "List.h"
#include <cassert>

List::List(int l, int r, int t, int b)
	:
	max_rect(l,r,t,b)
{}

void List::add_button(std::string t, Color c)
{
	assert(t.size() <= (max_rect.right - max_rect.left));
	int y = button.size() * 35 + max_rect.top;
	Button b(max_rect.left, t.size(), y, y + 28, t, c);
	button.push_back(b);
}

void List::remove_button(int i)
{
	if (i == (button.size() - 1))
		button.pop_back();
	else
	{
		int count = 0;
		for (auto& b : button)
		{
			if (count > i)
			{
				b.decrease_height(35);
			}
			count++;
		}
		button.erase(button.begin() + i);
	}
}

void List::print(Graphics& gfx,Font& f)
{
	for (auto& i:button)
	{
		if (i.get_bottom() <= max_rect.bottom)
			i.draw(gfx, f);
	}
}






ActionList::ActionList(int l, int r, int t, int b)
	:
	max_rect(l, r, t, b)
{}

void ActionList::add_button(std::string t, Color c, Action a)
{
	assert(t.size() <= (max_rect.right - max_rect.left));
	int y = button.size() * 35 + max_rect.top;
	ActionButton b(max_rect.left, t.size(), y, y + 28, t, c, a);
	button.push_back(b);
}

void ActionList::remove_button(int i)
{
	if (i == (button.size() - 1))
		button.pop_back();
	else
	{
		int count = 0;
		for (auto& b : button)
		{
			if (count > i)
			{
				b.decrease_height(35);
			}
			count++;
		}
		button.erase(button.begin() + i);
	}
}

void ActionList::print(Graphics& gfx, Font& f)
{
	for (auto& i : button)
	{
		if (i.get_bottom() <= max_rect.bottom)
			i.draw(gfx, f);
	}
}